
#include <stdio.h>
#include <string.h>
#include <stdlib.h>


typedef struct WYR {
	char *s;
	int len;
	WYR *nast;
} *PWYR;

PWYR hash[27];

int snlen,n;
char *snbuf, *tekst;

WYR *wyrbuf;
int wblen;

int *wyn;

inline int h(char c) { if( c>='A' && c<='Z' ) return (int)(c-'A'); return 26; }

inline int min( int a, int b ) { return a<b ? a:b; }

inline bool strncmp_( char *l, char *p, int n )
{
	while(n--)
	{
		if( *l != *p )
			return 1;
		l++; p++;
	}
	return 0;
}

void dodaj( char *s, int len )
{
	int ha = h(*s);
	WYR *nowy = wyrbuf+wblen;
	nowy->s = s;
	nowy->len = len;
	if( hash[ha] == NULL || hash[ha]->len >= len )
	{
//		if( hash[ha]!=NULL && strncmp_( hash[h(*s)]->s, s, min( hash[h(*s)]->len, len) )==0 )
//			return;
		nowy->nast = hash[ha];
		hash[ha] = nowy;
	}
	else
	{
		WYR *poprz = hash[ha];
		while ( poprz->nast && poprz->nast->len < len )
		{
//			if( strncmp_( poprz->s, s, poprz->len)==0 )
//				return;
			poprz = poprz->nast;
		}
//		if( poprz->nast && strncmp_( poprz->nast->s, s,  min( poprz->nast->len, len) )==0 )
//			return;
		nowy->nast = poprz->nast;
		poprz->nast = nowy;
	}

	wblen++;
}

int wczyt_sl( char *buf, int len )
{
	fgets( buf, len, stdin );
	len = strlen( buf );
	while( buf[len-1] != '*' && ( buf[len-1]<'A' || buf[len-1]>'Z' ) )
		len--;
//	printf( "w: %s %d\n", buf, len );
	return len;
}


int main()
{
	int d,tlen, imod;

	scanf( "%d", &d );
	
	tekst = (char*)malloc( 5000010*sizeof(char) );
	wyrbuf = (WYR*)malloc( 500010*sizeof(WYR) );
	wyn = (int*)malloc( 65536*sizeof(int) );
	snbuf = (char*)malloc( 500010*sizeof(char) );

	fgets( snbuf, 500010, stdin );
	while( d-- )
	{
		int i;
		memset( hash, 0, 27*sizeof(WYR*) );
		memset( wyn, 0, 65536 * sizeof(int) );
		scanf( "%d", &n );
		fgets( snbuf, 500010, stdin );
		snlen=0;
		wblen=0;
		for( i=0; i<n; i++ )
		{
			int len = wczyt_sl( snbuf+snlen, 60010 );
			dodaj( snbuf+snlen, len );
			snlen += len;
		}

		tlen = wczyt_sl( tekst, 5000010 );
//		tlen = 5000000;
//		for( i=0 ;i<5000000; i++ )
//			tekst[i]='A';

		imod=0;
		WYR *akt;
		for( i=0; i<tlen; i++ )
		{			
			if( wyn[imod]>wyn[i&65535] ) wyn[i&65535]=wyn[imod];

			wyn[imod]=0;
			imod = (i&65535);
			akt = hash[ h(tekst[i]) ];

//			printf("|");

			while( akt )
			{
//				printf(".");
//				fflush( stdout );
				if( akt->len > tlen-i )
					break;
				if(	wyn[(i+akt->len)&65535]<= wyn[imod] && strncmp_( tekst+i, akt->s, akt->len ) ==0 )
				{
					wyn[(i+akt->len)&65535] = wyn[imod]+1;
					break;
				}
				akt = akt->nast;
			}

			
		}
		if( wyn[imod]>wyn[i&65535] ) wyn[i&65535]=wyn[imod];

		printf( "%d\n", wyn[tlen&65535] );

	}
	
	return 0;
}

